Subject: Re: [stable] [patch 09/12] Fix SMP poweroff hangs

From: Olof Johansson <[email-masked]>
Date: Tue, 9 Oct 2007 19:03:18 -0500

On Tue, Oct 09, 2007 at 04:27:06PM -0700, Linus Torvalds wrote:
> 
> 
> On Wed, 10 Oct 2007, Thomas Gleixner wrote:
> > 
> > Wrapping it into a #ifdef CONFIG_X86 would be sufficient.
> 
> Well, the ppc oops seems to be a ppc bug regardless.
> 
> If CPU_HOTPLUG isn't defined, the thing does nothing. And if it is 
> defined, I don't see why/how ppc can validly oops. So I think the first 
> thing to do is to try to figure out why it oopses, not to disable it for 
> ppc.

The machine Paul tried on most likely has MPIC interrupt controller, and
the oops was when the pseries_cpu_disable tried calling XICS code instead.
It's not surprising that it failed, I don't think IBM has (traditionally)
cared about cpu hotplug on those machines.

So the PPC-side fix is to not enable cpu hotplug on mpic-based
systems. I'll follow up with a patch, but I have no way to test it since
I only have one POWER5 machine, no other IBM hardware. I'd appreciate
it if someone with hardware could verify it.

-Olof